#ifndef __PRAGMAS_VISUALC_H__
#define __PRAGMAS_VISUALC_H__

static long dmval = 0;

__inline static unsigned long getkensmessagecrc(long param)
{
    __asm
    {
        mov ebx, param
        xor eax, eax
        mov ecx, 32
        beg: mov edx, dword ptr [ebx+ecx*4-4]
        ror edx, cl
        adc eax, edx
        bswap eax
        loop short beg
        
    } /* asm */
}

__inline static long msqrtasm(int param)
{
    __asm
    {
        mov ecx, param
        mov eax, 0x40000000
        mov ebx, 0x20000000
        begit: cmp ecx, eax
        jl skip
        sub ecx, eax
        lea eax, [eax+ebx*4]
        skip: sub eax, ebx
        shr eax, 1
        shr ebx, 2
        jnz begit
        cmp ecx, eax
        sbb eax, -1
        shr eax, 1
        
    } /* asm */
}

__inline static int sqr(int i1)
{
    __asm
    {
        mov eax, i1
        imul eax, eax
        
    } /* asm */
    
}

__inline static long scale(long i1, long i2, long i3)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ecx, i3
        imul edx
        idiv ecx
        
    } /* asm */
    
}

__inline static long mulscale(long i1, long i2, long i3)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ecx, i3
        imul edx
        shrd eax, edx, cl
        
    } /* asm */
    
}

__inline static long mulscale1(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 1
        
    } /* asm */
    
}

__inline static long mulscale2(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 2
        
    } /* asm */
    
}

__inline static long mulscale3(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 3
        
    } /* asm */
    
}

__inline static long mulscale4(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 4
        
    } /* asm */
    
}

__inline static long mulscale5(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 5
        
    } /* asm */
    
}

__inline static long mulscale6(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 6
        
    } /* asm */
    
}

__inline static long mulscale7(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 7
        
    } /* asm */
    
}

__inline static long mulscale8(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 8
        
    } /* asm */
    
}

__inline static long mulscale9(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 9
        
    } /* asm */
    
}

__inline static long mulscale10(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 10
        
    } /* asm */
    
}

__inline static long mulscale11(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 11
        
    } /* asm */
    
}

__inline static long mulscale12(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 12
        
    } /* asm */
    
}

__inline static long mulscale13(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 13
        
    } /* asm */
    
}

__inline static long mulscale14(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 14
        
    } /* asm */
    
}

__inline static long mulscale15(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 15
        
    } /* asm */
    
}

__inline static long mulscale16(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 16
        
    } /* asm */
    
}

__inline static long mulscale17(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 17
        
    } /* asm */
    
}

__inline static long mulscale18(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 18
        
    } /* asm */
    
}

__inline static long mulscale19(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 19
        
    } /* asm */
    
}

__inline static long mulscale20(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 20
        
    } /* asm */
    
}

__inline static long mulscale21(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 21
        
    } /* asm */
    
}

__inline static long mulscale22(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 22
        
    } /* asm */
    
}

__inline static long mulscale23(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 23
        
    } /* asm */
    
}

__inline static long mulscale24(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 24
        
    } /* asm */
    
}

__inline static long mulscale25(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 25
        
    } /* asm */
    
}

__inline static long mulscale26(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 26
        
    } /* asm */
    
}

__inline static long mulscale27(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 27
        
    } /* asm */
    
}

__inline static long mulscale28(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 28
        
    } /* asm */
    
}

__inline static long mulscale29(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 29
        
    } /* asm */
    
}

__inline static long mulscale30(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 30
        
    } /* asm */
    
}

__inline static long mulscale31(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        shrd eax, edx, 31
        
    } /* asm */
    
}

__inline static long mulscale32(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        imul edx
        mov eax, edx
    } /* asm */
    
}

__inline static long dmulscale(long i1, long i2, long i3, long i4, long i5)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        mov ecx, i5
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, cl
        
    } /* asm */
    
}

__inline static long dmulscale1(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 1
        
    } /* asm */
    
}

__inline static long dmulscale2(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 2
        
    } /* asm */
    
}

__inline static long dmulscale3(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 3
        
    } /* asm */
    
}

__inline static long dmulscale4(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 4
        
    } /* asm */
    
}

__inline static long dmulscale5(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 5
        
    } /* asm */
    
}

__inline static long dmulscale6(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 6
        
    } /* asm */
    
}

__inline static long dmulscale7(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 7
        
    } /* asm */
    
}

__inline static long dmulscale8(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 8
        
    } /* asm */
    
}

__inline static long dmulscale9(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 9
        
    } /* asm */
    
}

__inline static long dmulscale10(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 10
        
    } /* asm */
    
}

__inline static long dmulscale11(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 11
        
    } /* asm */
    
}

__inline static long dmulscale12(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 12
        
    } /* asm */
    
}

__inline static long dmulscale13(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 13
        
    } /* asm */
    
}

__inline static long dmulscale14(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 14
        
    } /* asm */
    
}

__inline static long dmulscale15(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 15
        
    } /* asm */
    
}

__inline static long dmulscale16(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 16
        
    } /* asm */
    
}

__inline static long dmulscale17(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 17
        
    } /* asm */
    
}

__inline static long dmulscale18(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 18
        
    } /* asm */
    
}

__inline static long dmulscale19(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 19
        
    } /* asm */
    
}

__inline static long dmulscale20(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 20
        
    } /* asm */
    
}

__inline static long dmulscale21(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 21
        
    } /* asm */
    
}

__inline static long dmulscale22(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 22
        
    } /* asm */
    
}

__inline static long dmulscale23(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 23
        
    } /* asm */
    
}

__inline static long dmulscale24(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 24
        
    } /* asm */
    
}

__inline static long dmulscale25(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 25
        
    } /* asm */
    
}

__inline static long dmulscale26(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 26
        
    } /* asm */
    
}

__inline static long dmulscale27(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 27
        
    } /* asm */
    
}

__inline static long dmulscale28(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 28
        
    } /* asm */
    
}

__inline static long dmulscale29(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 29
        
    } /* asm */
    
}

__inline static long dmulscale30(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 30
        
    } /* asm */
    
}

__inline static long dmulscale31(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        shrd eax, edx, 31
        
    } /* asm */
    
}

__inline static long dmulscale32(long i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov esi, i3
        mov edi, i4
        imul edx
        mov ebx, eax
        mov eax, esi
        mov esi, edx
        imul edi
        add eax, ebx
        adc edx, esi
        mov eax, edx
    } /* asm */
    
}

__inline static long tmulscale1(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 1
        
    } /* asm */
    
}

__inline static long tmulscale2(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 2
        
    } /* asm */
    
}

__inline static long tmulscale3(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 3
        
    } /* asm */
    
}

__inline static long tmulscale4(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 4
        
    } /* asm */
    
}

__inline static long tmulscale5(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 5
        
    } /* asm */
    
}

__inline static long tmulscale6(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 6
        
    } /* asm */
    
}

__inline static long tmulscale7(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 7
        
    } /* asm */
    
}

__inline static long tmulscale8(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 8
        
    } /* asm */
    
}

__inline static long tmulscale9(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 9
        
    } /* asm */
    
}

__inline static long tmulscale10(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 10
        
    } /* asm */
    
}

__inline static long tmulscale11(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 11
        
    } /* asm */
    
}

__inline static long tmulscale12(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 12
        
    } /* asm */
    
}

__inline static long tmulscale13(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 13
        
    } /* asm */
    
}

__inline static long tmulscale14(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 14
        
    } /* asm */
    
}

__inline static long tmulscale15(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 15
        
    } /* asm */
    
}

__inline static long tmulscale16(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 16
        
    } /* asm */
    
}

__inline static long tmulscale17(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 17
        
    } /* asm */
    
}

__inline static long tmulscale18(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 18
        
    } /* asm */
    
}

__inline static long tmulscale19(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 19
        
    } /* asm */
    
}

__inline static long tmulscale20(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 20
        
    } /* asm */
    
}

__inline static long tmulscale21(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 21
        
    } /* asm */
    
}

__inline static long tmulscale22(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 22
        
    } /* asm */
    
}

__inline static long tmulscale23(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 23
        
    } /* asm */
    
}

__inline static long tmulscale24(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 24
        
    } /* asm */
    
}

__inline static long tmulscale25(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 25
        
    } /* asm */
    
}

__inline static long tmulscale26(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 26
        
    } /* asm */
    
}

__inline static long tmulscale27(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 27
        
    } /* asm */
    
}

__inline static long tmulscale28(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 28
        
    } /* asm */
    
}

__inline static long tmulscale29(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 29
        
    } /* asm */
    
}

__inline static long tmulscale30(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 30
        
    } /* asm */
    
}

__inline static long tmulscale31(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        shrd eax, edx, 31
        
    } /* asm */
    
}

__inline static long tmulscale32(long i1, long i2, long i3, long i4, long i5, long i6)
{
    __asm
    {
        mov eax, i1
        mov edx, i2
        mov ebx, i3
        mov ecx, i4
        mov esi, i5
        mov edi, i6
        imul edx
        xchg eax, ebx
        xchg edx, ecx
        imul edx
        add ebx, eax
        adc ecx, edx
        mov eax, esi
        imul edi
        add eax, ebx
        adc edx, ecx
        mov eax, edx
    } /* asm */
    
}

__inline static long boundmulscale(long i1, long i2, long i3)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov ecx, i3
        imul ebx
        mov ebx, edx
        shrd eax, edx, cl
        sar edx, cl
        xor edx, eax
        js checkit
        xor edx, eax
        jz skipboundit
        cmp edx, 0xffffffff
        je skipboundit
        checkit:
        mov eax, ebx
        sar eax, 31
        xor eax, 0x7fffffff
        skipboundit:
        
    } /* asm */
    
}

__inline static long divscale(long i1, long i2, long i3)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov ecx, i3
        mov edx, eax
        shl eax, cl
        neg cl
        sar edx, cl
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale1(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        add eax, eax
        sbb edx, edx
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale2(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 30
        lea eax, [eax*4]
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale3(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 29
        lea eax, [eax*8]
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale4(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 28
        shl eax, 4
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale5(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 27
        shl eax, 5
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale6(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 26
        shl eax, 6
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale7(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 25
        shl eax, 7
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale8(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 24
        shl eax, 8
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale9(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 23
        shl eax, 9
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale10(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 22
        shl eax, 10
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale11(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 21
        shl eax, 11
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale12(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 20
        shl eax, 12
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale13(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 19
        shl eax, 13
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale14(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 18
        shl eax, 14
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale15(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 17
        shl eax, 15
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale16(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 16
        shl eax, 16
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale17(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 15
        shl eax, 17
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale18(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 14
        shl eax, 18
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale19(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 13
        shl eax, 19
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale20(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 12
        shl eax, 20
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale21(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 11
        shl eax, 21
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale22(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 10
        shl eax, 22
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale23(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 9
        shl eax, 23
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale24(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 8
        shl eax, 24
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale25(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 7
        shl eax, 25
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale26(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 6
        shl eax, 26
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale27(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 5
        shl eax, 27
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale28(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 4
        shl eax, 28
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale29(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 3
        shl eax, 29
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale30(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 2
        shl eax, 30
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale31(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov edx, eax
        sar edx, 1
        shl eax, 31
        idiv ebx
        
    } /* asm */
    
}

__inline static long divscale32(long i1, long i2)
{
    __asm
    {
        mov edx, i1
        mov ebx, i2
        xor eax, eax
        idiv ebx
        
    } /* asm */
    
}

__inline static void clearbuf(void *buf, long i2, long i3)
{
    __asm
    {
        mov edi, buf
        mov ecx, i2
        mov eax, i3
        rep stosd
    } /* asm */
}

__inline static void clearbufbyte(void *buf, long i2, long i3)
{
    __asm
    {
        mov edi, buf
        mov ecx, i2
        mov eax, i3
        cmp ecx, 4
        jae longcopy
        test cl, 1
        jz preskip
        stosb
        preskip: shr ecx, 1
        rep stosw
        jmp endit
        longcopy: test edi, 1
        jz skip1
        stosb
        dec ecx
        skip1: test edi, 2
        jz skip2
        stosw
        sub ecx, 2
        skip2: mov ebx, ecx
        shr ecx, 2
        rep stosd
        test bl, 2
        jz skip3
        stosw
        skip3: test bl, 1
        jz endit
        stosb
        endit:
    } /* asm */
}

__inline static void copybuf(void *src, void *dst, long len)
{
    __asm
    {
        mov esi, src
        mov edi, dst
        mov ecx, len
        rep movsd
    } /* asm */
}

__inline static void copybufbyte(void *src, void *dst, long len)
{
    __asm
    {
        mov esi, src
        mov edi, dst
        mov ecx, len
        cmp ecx, 4
        jae longcopy
        test cl, 1
        jz preskip
        movsb
        preskip: shr ecx, 1
        rep movsw
        jmp endit
        longcopy: test edi, 1
        jz skip1
        movsb
        dec ecx
        skip1: test edi, 2
        jz skip2
        movsw
        sub ecx, 2
        skip2: mov ebx, ecx
        shr ecx, 2
        rep movsd
        test bl, 2
        jz skip3
        movsw
        skip3: test bl, 1
        jz endit
        movsb
        endit:
    } /* asm */
}

__inline static void copybufreverse(void *src, void *dst, long len)
{
    __asm
    {
        mov esi, src
        mov edi, dst
        mov ecx, len
        shr ecx, 1
        jnc skipit1
        mov al, byte ptr [esi]
        dec esi
        mov byte ptr [edi], al
        inc edi
        skipit1: shr ecx, 1
        jnc skipit2
        mov ax, word ptr [esi-1]
        sub esi, 2
        ror ax, 8
        mov word ptr [edi], ax
        add edi, 2
        skipit2: test ecx, ecx
        jz endloop
        begloop: mov eax, dword ptr [esi-3]
        sub esi, 4
        bswap eax
        mov dword ptr [edi], eax
        add edi, 4
        dec ecx
        jnz begloop
        endloop:
    } /* asm */
}

__inline static void qinterpolatedown16(long *i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov ecx, i2
        mov edx, i3
        mov esi, i4
        mov ebx, ecx
        shr ecx, 1
        jz skipbegcalc
        begqcalc: lea edi, [edx+esi]
        sar edx, 16
        mov dword ptr [eax], edx
        lea edx, [edi+esi]
        sar edi, 16
        mov dword ptr [eax+4], edi
        add eax, 8
        dec ecx
        jnz begqcalc
        test ebx, 1
        jz skipbegqcalc2
        skipbegcalc: sar edx, 16
        mov dword ptr [eax], edx
        skipbegqcalc2:
    } /* asm */
}

__inline static void qinterpolatedown16short(long *i1, long i2, long i3, long i4)
{
    __asm
    {
        mov eax, i1
        mov ecx, i2
        mov edx, i3
        mov esi, i4
        test ecx, ecx
        jz endit
        test al, 2
        jz skipalignit
        mov ebx, edx
        sar ebx, 16
        mov word ptr [eax], bx
        add edx, esi
        add eax, 2
        dec ecx
        jz endit
        skipalignit: sub ecx, 2
        jc finishit
        begqcalc: mov ebx, edx
        add edx, esi
        sar ebx, 16
        mov edi, edx
        and edi, 0ffff0000h
        add edx, esi
        add ebx, edi
        mov dword ptr [eax], ebx
        add eax, 4
        sub ecx, 2
        jnc begqcalc
        test cl, 1
        jz endit
        finishit: mov ebx, edx
        sar ebx, 16
        mov word ptr [eax], bx
        endit:
    } /* asm */
}

__inline static void vlin16first(long i1, long i2)
{
    __asm
    {
        mov edi, i1
        mov ecx, i2
        mov al, byte ptr [edi]
        mov eax, ecx
        shr ecx, 2
        begvlin16firsta: mov byte ptr [edi], al
        mov byte ptr [edi+80], al
        mov byte ptr [edi+160], al
        mov byte ptr [edi+240], al
        add edi, 320
        dec ecx
        jnz begvlin16firsta
        mov ecx, eax
        and ecx, 3
        jz skipfirst
        begvlin16firstb: mov byte ptr [edi], al
        add edi, 80
        dec ecx
        jnz begvlin16firstb
        skipfirst:
    } /* asm */
}

__inline static void vlin16(long i1, long i2)
{
    __asm
    {
        mov edi, i1
        mov ecx, i2
        mov esi, edi
        begvlin16: movsb
        add edi, 79
        add esi, 79
        dec ecx
        jnz begvlin16
    } /* asm */
}

__inline static long mul3(long i1)
{
    __asm
    {
        mov eax, i1
        lea eax, [eax+eax*2]
        
    } /* asm */
    
}

__inline static long mul5(long i1)
{
    __asm
    {
        mov eax, i1
        lea eax, [eax+eax*4]
        
    } /* asm */
    
}

__inline static long mul9(long i1)
{
    __asm
    {
        mov eax, i1
        lea eax, [eax+eax*8]
        
    } /* asm */
    
}

        /* urns eax/ebx, dmval = eax%edx; */
__inline static long divmod(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        xor edx, edx
        div ebx
        mov dmval, edx
        
    } /* asm */
    
}

        /* urns eax%ebx, dmval = eax/edx; */
__inline static long moddiv(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        xor edx, edx
        div ebx
        mov dmval, eax
        mov i1, edx
    } /* asm */
    
}

__inline static long klabs(long i1)
{
    __asm
    {
        mov eax, i1
        test eax, eax
        jns skipnegate
        neg eax
        skipnegate:
        
    } /* asm */
    
}

__inline static long ksgn(long i1)
{
    __asm
    {
        mov ebx, i1
        add ebx, ebx
        sbb eax, eax
        cmp eax, ebx
        adc al, 0
        
    } /* asm */
    
}

__inline static long sgn(long i1)
{
    __asm
    {
        mov ebx, i1
        add ebx, ebx
        sbb eax, eax
        cmp eax, ebx
        adc eax, 0
    } /* asm */
    
}

        /* eax = (unsigned min)umin(eax,ebx) */
__inline static long umin(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        sub eax, ebx
        sbb ecx, ecx
        and eax, ecx
        add eax, ebx
        
    } /* asm */
    
}

        /* eax = (unsigned max)umax(eax,ebx) */
__inline static long umax(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        sub eax, ebx
        sbb ecx, ecx
        xor ecx, 0xffffffff
        and eax, ecx
        add eax, ebx
        
    } /* asm */
    
}

__inline static long kmin(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        cmp eax, ebx
        jl skipit
        mov eax, ebx
        skipit:
        
    } /* asm */
    
}

__inline static long kmax(long i1, long i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        cmp eax, ebx
        jg skipit
        mov eax, ebx
        skipit:
        
    } /* asm */
    
}

__inline static void swapchar(char *i1, char *i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov cl, [eax]
        mov ch, [ebx]
        mov [ebx], cl
        mov [eax], ch
        
    } /* asm */
}

__inline static void swapshort(short *i1, short *i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov cx, [eax]
        mov dx, [ebx]
        mov [ebx], cx
        mov [eax], dx
        
    } /* asm */
}

__inline static void swaplong(long *i1, long *i2)
{
    __asm
    {
        mov eax, i1
        mov ebx, i2
        mov ecx, [eax]
        mov edx, [ebx]
        mov [ebx], ecx
        mov [eax], edx
        
    } /* asm */
}


        /*
         * swapchar2(ptr1,ptr2,xsiz); is the same as:
         * swapchar(ptr1,ptr2); swapchar(ptr1+1,ptr2+xsiz);
		 */ 
__inline static void swapchar2(char *ptr1, char *ptr2, long xsiz)
{
   __asm
   {
        mov eax, ptr1
        mov ebx, ptr2
        mov esi, xsiz
        add esi, ebx
        mov cx, [eax]
        mov dl, [ebx]
        mov [ebx], cl
        mov dh, [esi]
        mov [esi], ch
        mov [eax], dx
    } /* asm */
}

#endif